import scipy.misc
from cae import CAE
import numpy as np
import os

caeFile = '/home/torstein/dqn_runs/cae/qb_small_correct/cae_weights.npz'
imgFolder = '/home/torstein/orgDec/GSAE_qbert/'
folder = '/tmp/cae_temp5ab245'
fname = '/home/torstein/dqn_runs/ds/qbert.npz'
ds = [fname]

if not os.path.exists(imgFolder):
    os.makedirs(imgFolder)

cae = CAE(
    folder = folder, 
    ds = ds,
    lr = 0.001,
    batchSize=32,
    epochs=31,
    # optimization_type='SGD', 
    optimization_type='RMSprop', 
    bufferSize=2048, 
)
cae.load(caeFile)


f = np.load(fname)
phis = f['phi'] 

indices = np.random.choice(10000, 32, replace=False) 
test_phi = np.take(phis, indices, axis=0)

dec = cae.encodeDecode(test_phi)

for i, t in enumerate(zip(test_phi, dec)): 
    o, d = t
    scipy.misc.toimage(o[0], cmin=0.0, cmax=1.0).save(imgFolder + str(i) + 'org.jpg')
    scipy.misc.toimage(d[0], cmin=0.0, cmax=1.0).save(imgFolder + str(i) + 'dec.jpg')