import os
import sys
import subprocess
from dqn import DQN
from random import randint


if __name__ == '__main__':
    args = sys.argv
    largs = len(args)

    if largs == 4: 
        game = args[1]
        name = args[2]
        network = args[3]
    else: 
        print 'Usage: game, name/label, network. '
        sys.exit()


    gamePath = '/home/torstein/dqn/games/' + game + '.bin'
    temp = '/tmp/dqn_mov/' + str(randint(0,10000000))
    folder = '/home/torstein/records/' + name

    if not os.path.exists(folder):
        os.makedirs(folder)
    else: 
        print 'Give anouther label, it already exists'
        sys.exit()

    dqn = DQN(
        folder = temp, 
        gamePath = gamePath, 
        repMem = 100, 
    )

    dqn.load(network)
    dqn.testGui(1, record=folder)
    command = 'ffmpeg -r 60 -i %s/%%06d.png -i %s/sound.wav -f mov -c:a mp3 -c:v libx264 %s/%s.mov' % (folder, folder, folder, name)
    process = subprocess.Popen(command, shell=True)
    process.wait()
