import sys
import os
import pickle
import numpy as np
from dqn import DQN



if __name__ == '__main__':
    args = sys.argv
    largs = len(args)

    if largs >= 3: 
        game = args[1]
        folder = args[2]
    else: 
        print 'Usage: game, folder'

    if largs == 4: 
        e = float(args[3])
    else: 
        e = 0.05

    #game = 'breakout'
    #game = 'montezuma_revenge'
    #game = 'qbert'
    #game = 'road_runner'
    #game = 'double_dunk'
    #game = 'space_invaders'

    #caeFname = None 
    #caeFname = '/media/torstein/data/dqn_runs/cae/breakout_qbert_space_road_double_1/cae_weights.npz'
    #caeFname = '/home/torstein/dqn_runs/cae/imagenet_small/cae_e5.npz'
    gamePath = '/home/torstein/dqn/games/' + game + '.bin'

    dqn = DQN(
        folder = folder, #'/tmp/dqn_runs/TEST_%s_%s' % (game, timestamp),
        gamePath = gamePath, 
        repMem = 100, 
        testing = True, 
    )
    files = [f for f in os.listdir(folder) if os.path.isfile(os.path.join(folder, f))]
    files = [f for f in files if f.startswith('step') and f.endswith('.npz')]

    def comp(s1,s2): 
        return np.clip(int(s1[4:-4]) - int(s2[4:-4]), -1, 1) 
    files.sort(cmp=comp)

    res = []
    for f in files: 
        dqn.load(os.path.join(folder, f))
        avgScore, scores = dqn.test(verbose=True, e=e)
        res.append((f, avgScore, scores))
    dqn.logger.info('All results: ' + str(res))

    if e == 0.05: 
        resName = folder + '/res.dat'
    else: 
        resName = folder + '/res' + str(e) + '.npz'
    with open(resName, 'wb') as f: 
        pickle.dump(res, f)