import sys
from dqn import DQN
import numpy as np


if __name__ == '__main__':
    args = sys.argv
    largs = len(args)

    if largs >= 3: 
        game = args[1]
        name = args[2]
    else: 
        print 'Usage: game, name/label, pcae, cae case. '
        sys.exit()

    if largs >= 4: 
        caeFname = args[3]
    else: 
        caeFname = None

    if largs >= 5: 
        caeCase = int(args[4])

    if largs == 6: 
        frozzenLevel = int(args[5]) 
    else: 
        frozzenLevel = -1
        
    if largs >= 7: 
        print 'Usage: game, name/label, pcae, cae case. '
        sys.exit()

    #game = 'breakout'
    #game = 'montezuma_revenge'
    #game = 'qbert'
    #game = 'road_runner'
    #game = 'double_dunk'
    #game = 'space_invaders'

    #caeFname = None 
    #caeFname = '/media/torstein/data/dqn_runs/cae/breakout_qbert_space_road_double_1/cae_weights.npz'
    #caeFname = '/home/torstein/dqn_runs/cae/imagenet_small/cae_e5.npz'

    if caeFname: 
        name = name + '_case%i' % caeCase

        if not caeFname.startswith('/'): 
            caeFname = '/home/torstein/dqn_runs/cae/' + caeFname

    gamePath = '/home/torstein/dqn/games/' + game + '.bin'
    folder = '/home/torstein/dqn_runs/long/' + game + '/' + name
    dqn = DQN(
        folder = folder, 
        gamePath = gamePath, 
        frozzenLevel = frozzenLevel,
        steps = 10000010, 
        # targetNetworkUpdateFrequency = 10000,
        # doubleDQN = False,
        # steps = 10000010, 
        # steps = 2000, 
        # trainStartStep = 500, 
        # weightStatusIntervall = 500,
        # repMem = 3000, 
        # repMem = 500000,
        # trainPredNet = True,
        # batch_acc = 'mean',
        # optimization_type = 'RMSprop_momentum'
        # lr=0.0005,
    )
    # dqn.loggMessage('Testing uniform sampling of epsilon. ')
    if caeFname: 
        dqn.loadCae(caeFname, case=caeCase)
    dqn.train()
